Index: debian/patches/series
===================================================================
--- debian/patches/series	(Revision 3860)
+++ debian/patches/series	(Arbeitskopie)
@@ -10,3 +10,4 @@
 array_subscripts_warning.patch
 i18n_increase_array_sizes.patch
 mouse_cursor_without_font.patch
+bug439393.patch
Index: debian/patches/bug439393.patch
===================================================================
--- debian/patches/bug439393.patch	(Revision 0)
+++ debian/patches/bug439393.patch	(Revision 0)
@@ -0,0 +1,87 @@
+# Copyright (C) 2007  Jens Seidel <jensseidel@users.sf.net> (comments)
+# Licensed under the GPL, see /usr/share/common-licenses/GPL
+
+Index: hex-a-hop.svn/gfx.cpp
+===================================================================
+--- hex-a-hop.svn.orig/gfx.cpp	2007-08-27 01:34:03.000000000 +0200
++++ hex-a-hop.svn/gfx.cpp	2007-08-27 01:38:18.000000000 +0200
+@@ -17,6 +17,7 @@
+ */
+ 
+ #include "i18n.h"
++#include <iostream>
+ 
+ #include "state.h"
+ #include <cassert>
+@@ -196,7 +197,19 @@
+ 	// http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=439071
+ 	if (text_utf8.size() == 0 || text_utf8.size() == 1 && text_utf8[0]==127)
+ 		return;
++	//  std::cout << "Print_Pango: " << x << ", " << y << " text=" << text_utf8 << "#\n";
+ 	assert(text_utf8.find("\n") == std::string::npos);
++	assert(x>=0 && x<SCREEN_W && y>=0 && y<SCREEN_H);
++	int real_width = SDLPangoTextWidth(text_utf8);
++	// TODO: Do not forget y checks! Was SDLPango_SetMinimumSize properly called?
++	if (x+real_width>=SCREEN_W) { // we have one pixel more but ...
++		std::cerr << "Whoops, text too large, word wrap failed! Repositioning ..." << std::endl;
++		x = SCREEN_W-1-real_width;
++		if (x<0) {
++			std::cerr << "Text is much too wide!!!\nSkipping ..." << std::endl;
++			return;
++		}
++	}
+ 	SDLPango_SetText(context, text_utf8.c_str(), -1);
+ 	SDL_Surface *surface = SDLPango_CreateSurfaceDraw(context);
+ 	SDL_Rect dst = {x, y, 1, 1};
+@@ -222,7 +235,26 @@
+ 	if (text_utf8.size() == 0 || text_utf8.size() == 1 && text_utf8[0]==127)
+ 		return;
+ 	assert(width>0);
++	assert(x-width/2>=0 && x-width/2+width<SCREEN_W && y>=0 && y<SCREEN_H);
+ 	SDLPango_SetMinimumSize(context, width, 0);
++	int real_width = SDLPangoTextWidth(text_utf8);
++	//  if (real_width>width)
++	//		std::cout << "PrintC_Pango 1: " << x << ", " << y << " width=" << width << " real width=" << real_width << " text=" << text_utf8 << "#\n";
++	int old_width = width;
++	width = std::max(width, real_width); // CHECKME
++	if (x-width/2+real_width>=SCREEN_W) { // we have one pixel more but ...
++		std::cout << "PrintC_Pango: " << x << ", " << y << " width=" << old_width << " text=" << text_utf8 << "#\n";
++		std::cerr << "Whoops, centered text too large, word wrap failed! Repositioning to ";
++		x = SCREEN_W-1-real_width+width/2 - 2/* 2: to be save, avoid rounding problems?*/;
++		std::cerr << x << "," << y << " (real width=" << real_width << ")" << std::endl;
++		assert(/*x-width/2>=0 &&*/ x-width/2+real_width<SCREEN_W && y>=0 && y<SCREEN_H);
++		if (x-width/2 <= 0) { // <0 should be sufficient ...
++			std::cerr << "Centered text is much too wide!!!\nSkipping ..." << std::endl;
++			return;
++		}
++		// use larger real width, otherwise it still crashs if line break is not possible!?
++		SDLPango_SetMinimumSize(context, width+1, 0); // BUG!! Move this to (SDL)Pango!!!
++	}
+ 
+ 	// SDLPango_SetText_GivenAlignment is not (yet?) part of the official Pango
+ 	// distribution, see http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=437865
+Index: hex-a-hop.svn/hex_puzzzle.cpp
+===================================================================
+--- hex-a-hop.svn.orig/hex_puzzzle.cpp	2007-08-27 01:34:08.000000000 +0200
++++ hex-a-hop.svn/hex_puzzzle.cpp	2007-08-27 01:37:37.000000000 +0200
+@@ -453,7 +453,19 @@
+ 			if (!std::isspace(tmp[i]))
+ 				print = false;
+ 	}
+-	PrintC(split, x, y, 2*std::min(x, SCREEN_W-x), "%s", tmp);
++	if (x<3) {
++		std::cout << "Error in PrintC: x too small " << x << " " << tmp << std::endl;
++		x=15;
++	}
++	if (x>SCREEN_W-1-3) {
++		std::cout << "Error in PrintC: x too large " << x << " " << tmp << std::endl;
++		x=SCREEN_W-1-15;
++	}
++	if (y<1) {
++		std::cout << "Error in PrintC: y too small " << y << " " << tmp << std::endl;
++		y=5;
++	}
++	PrintC(split, x, y, 2*std::min(x, SCREEN_W-2/*1.5 should be sufficent, but isn't!*/-x), "%s", tmp);
+ }
+ 
+ #include "savestate.h"
